/******************************************************************************
 SCI Template Game
 By Brian Provinciano
 Large parts written and modified by Matthew Jones
 
 ******************************************************************************
 main.sc
 Contains the game's main instance and inventory items.
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script MAIN_SCRIPT)
/******************************************************************************/
(use "controls")
(use "sound")
(use "syswindow")
(use "cycle")
(use "game")
(use "inv")
(use "user")
(use "menubar")
(use "feature")
(use "obj")
(use "disposeload")
(use "wander")
(use "timer")

/******************************************************************************
 * These are the global variables. You can access them from any script as long
 * as it "use"es this script
 ******************************************************************************/
(local
	gEgo					/* points to the ego's class */
	gGame					/* points to the game instance */
	gRoom					/* points to the current room instance */
	gSpeed 					/* the game speed (delay each interpreter cycle) */
	gQuitGame = FALSE		/* if set to TRUE, the game will exit */
	
	gCast					/* points to the cast class (list of actors) */
	gRegions				/* points to the regions class (list of regions) */
	gLocales 				/* points to the locales class (list of locales) */
	gTimers					/* points to the timers class (list of timers) */
	gSounds					/* points to the sounds class (list of sounds) */
	gInv					/* points to the inventory class */
	gAddToPics				/* points to the add to pics class */
	gFeatures				/* points to the add to features class */		
	gSFeatures				/* points to the add to sfeatures class */
	
	gRoomNumberExit			/* room number exit */
	gPreviousRoomNumber		/* the number of the previous room */
	gRoomNumber				/* the number of the current room */ 
	gDebugOnExit = FALSE	/* enter debug mode on room exit */ 
	
	gScore = 0				/* the game score */		
	gMaxScore = 68			/* the maximum game score */
	gOldScore				/* previous score */
	
	gCurrentCursor			/* the number of the current cursor */
	gNormalCursor = 999		/* the number of the normal cursor (ie. arrow) */
	gLoadingCursor = 997	/* the number of the loading cursor (ie. hand) */
	
	gDefaultFont = 1		/* the number of the default font */
	gSaveRestoreFont = 0	/* the number of the font for the save/restore dialogs*/
	gDeadFont = 0			/* the number of the font for the dialog when ego dies */
	
	gUserEvent				/* points to the user's event object */
	gPrintDlg				/* points to the current Print() window */
	gVolume					/* the sound volume */
	gVersion				/* the version string */
	gSaveDirPtr				/* points to the save directory string */
	gCheckAniWait			/* the checkAni delay */
	gSetRegions				/* a flag -- see User:doit() */
	
	gPicAngle				/* the room's pic angle */
	gOverlay = -1			/* whether to overlay the picture when drawing */
	gDefaultPicAni			/* the default pic animation */
	gDefaultPalette			/* the default palette to use for the pictures (0-3) */
	gCastMotionCue			/* if set, the cast's motionCue() is called */
	
	gTheWindow				/* points to the window class */
	gWndColor				/* the colour of the game's windows foreground (ie. text) */
	gWndBack				/* the colour of the game's windows background */

	gOldPort				/* the previous port */
	
	gEgoView				/* ego's current view number */
	
	/* hh:mm:ss | gTimeHours:gTimeMinutes:gTimeSeconds */
	/* the time elapsed since the game started */
	gTimeSeconds			/* the seconds */
	gTimeMinutes			/* the minutes */
	gTimeHours				/* the hours */
	
	gCurrentTime				/* the current time in seconds */
	
	gTheMusic				/* points to the music class */
	gTheSoundFX				/* points to the sound fx class */
	gProgramControl 		/* states whether the program has control or the user */

    //Our Globals
    //Not really important because you can't drink too many
    beersLeft  = 6
    //Set to count the number of beers drank
    beersDrank = 0
    //Set when you're drunk
    Drunk      = 0
    //Set when you have Emma
    gotEmma    = 0
    //Set when you have Carmen
    gotCarmen  = 0
    //Set when you have Ana
    gotAna     = 0
    //Set when there is a CD in the radio
    cdInRadio  = 0
    //Set when the radio is on
    RadioOn    = 0
    //Ana is sleeping
    anaIsSleeping=1
    //Machine played on answering machine
    messagePlayed=0
    //Used beer on the poster
    usedBeerOnPoster = 0
    //Set when the bear is knocked out
    bearOut = 0
    //Set when the beer is unlocked
    beerUnlock = 0
    //Set when the mirror falls out of the tree
    mirrorDropped = 0
    //Set when Emma falls out of the tree
    emmaFallen = 0
    //Set when all of the girls are gathered
    gotAllGirls = 0
    //Used to say whether or not the player releived themselves
    tookLeak = 0
    //Warp past the annoying cliff
    cliffWarp = 0
    //If we read the note yet
    readEndNote = 0
    //Hint Counter for hints in the game
    hintCounter = 0
)

/******************************************************************************/
(instance public HCRA of Game
	(properties)
	(method (init)
        // Set up the base window
		= gTheWindow theWindow
		= gWndColor clBLACK
		= gWndBack clWHITE
        
		(send gTheWindow:
			color(gWndColor)
		    back(gWndBack)
		)

        // Initialize
		(super:init())

        /******************************
         * Set your game version here *
         ******************************/
		= gVersion "1.0"
		    
		// General initialization stuff
	    = gVolume 15
	    DoSound(sndVOLUME gVolume)
		    
	    (SL:code(statusCode))
	    (TheMenuBar:init())
    
	    (scoreSound:
	    	owner(self)
	    	init()
	    )
	    = gTheMusic theMusic
	    (send gTheMusic:
	    	owner(self)
	    	init()
	    )
		= gTheSoundFX theSoundFX
	    (send gTheSoundFX:
	    	owner(self)
	    	init()
	    )
	    
	    = gEgo ego
	    (User:
	    	alterEgo(gEgo)
	    	blocks(0)
	    	y(150)
	    )
			
		Load(rsFONT		gDeadFont)
		Load(rsFONT		gDefaultFont)
		Load(rsFONT		gSaveRestoreFont)
	
		Load(rsCURSOR	gNormalCursor)
		Load(rsCURSOR	gLoadingCursor)
			
	    (if(HaveMouse())
	    	(send gGame:setCursor(gNormalCursor SET_CURSOR_VISIBLE))
		)(else
	    	(send gGame:setCursor(gNormalCursor SET_CURSOR_VISIBLE 304 174))
		)
			
        /*************************************************
         * Initialize the inventory with it's items here *
         *************************************************/
		(Inv:
			add(
				{Nothing}
                {Six Pack}
                {Hot Chicks Room Key}
				{Carmen Picture}
                {Emma Picture}
                {Ana Picture}
                {Magic Mirror}
                {Beer Key}
                {Radio}
                {Barry White Greatest Hits CD}
			)
		)
			
		// Start the room
		(if(GameIsRestarting())
	    	(self:newRoom(INITROOMS_SCRIPT))
	    )(else
	    	(self:newRoom(TITLESCREEN_SCRIPT))
		)
	)
	(method (doit)
		(super:doit())
		(if(gProgramControl)
			(User:
				canControl(FALSE)
				canInput(FALSE)
			)
		)
		(if(<> gCurrentTime (= gCurrentTime GetTime(gtTIME_OF_DAY)))
		    (if(>= ++gTimeSeconds 60)
		    	= gTimeSeconds 0
		    	++ gTimeMinutes
		    	(if(>= gTimeMinutes 60)
		    		= gTimeMinutes 0
		    		++ gTimeHours
		    	)
			)
		)
  		(if(> gOldScore gScore)
		    	= gOldScore gScore
				(SL:doit())
		)
		(if(< gOldScore gScore)
		    = gOldScore gScore
			(SL:doit())
		)
        //When you got all of the girls you have to handle this
        (if (== gotAllGirls 0)
            (if ((== gotEmma 1) and (== gotCarmen 1) and (== gotAna 1))
            Print("Well, thats all of them, you should go back to the Hot Chicks Room to check on the girls!")
            (send gGame:changeScore(3))
            = gotAllGirls 1
        )
    )
	)
	(method (replay)
  		(TheMenuBar:draw())
  		(SL:enable())
  		
  		(if(DoSound(sndSET_SOUND))
		    SetMenu(MENU_TOGGLESOUND #text "Turn Off")
		)(else
		    SetMenu(MENU_TOGGLESOUND #text "Turn On")
		)
		(super:replay())
	)
	(method (newRoom roomNum picAni)
  			DisposePrintDlg()
  			Load(rsFONT		gDeadFont)
  			Load(rsFONT		gDefaultFont)
  			Load(rsFONT		gSaveRestoreFont)

  			Load(rsCURSOR	gNormalCursor)
  			Load(rsCURSOR	gLoadingCursor)
     
			(super:newRoom(roomNum))
			(if(< paramTotal 2)
				= gDefaultPicAni Random(0 5)
			)(else
				= gDefaultPicAni picAni
			)
	)
	(method (startRoom roomNum)
		DisposeLoad(
			NULL
			FILEIO_SCRIPT JUMP_SCRIPT EXTRA_SCRIPT WINDOW_SCRIPT
		        TIMER_SCRIPT FOLLOW_SCRIPT REV_SCRIPT DCICON_SCRIPT
		        DOOR_SCRIPT AUTODOOR_SCRIPT
		)
		DisposeScript(DISPOSELOAD_SCRIPT)
		(if(gDebugOnExit)
			= gDebugOnExit FALSE
			SetDebug()
		)
		(send gTheSoundFX:
			stop()
			number(1)
		)
		(super:startRoom(roomNum))
		(if(== gTheSoundFX 11)
		 	(send gEgo:baseSetter(NormalBase))
		)
	)
	(method (changeScore addScore)
		= gScore + gScore addScore
		(if(> addScore 0)
			(scoreSound:playMaybe())
		)
	)
  	(method (handleEvent pEvent)
        (var dist2,x,y,endDrink,dyingScript)


        (if (<> Drunk 1)
		(super:handleEvent(pEvent))
        )
		(if((<> (send pEvent:type) evSAID) or (send pEvent:claimed))
		    return(TRUE)
		)

        /***********************************/
        /* Add global said statements here */
        /***********************************/
        //Drunk handler is broken!
        /*
        (if((== Drunk 1))
            (switch(Random(1 3))
              (case 1
              Print("odjsof OJDS oewhjr HJEOR aJS")
              )
              (case 2
              Print("DOJF eojr JEORJE erojaDSJOD")
              )
              (case 3
              Print("GOHDASiereuir OHJEWAjreojrero ffgFGFJO!!!DOJFJ?!?!")
              )
            )
            return(FALSE)
        )
        */
        (if(Said('hi'))
            Print("Well hello to you too!")
        )

        (if(Said('shit'))
            Print("There is no need to use the bathroom in this game")
        )


        (if(Said('hump,kiss'))
            Print("As cool as that would be (Since the chicks ARE hot), you "+
                  "cannot do that in this game")
        )
        
        (if(Said('talk'))
            Print("You talk to yourself for awhile. Very entertaining!")
        )
        
        (if(Said('kill'))
            Print("This is a non-violent game! None of that action is needed")
        
        )
        (if((Said('take/leak')) or (Said('pee')))
            Print("You're not going to relieve yourself here!")
        )

        //Global beer handler!
        (if(Said('drink/beer'))
        //Check how many beers you've drank
            (if ( (not (send gEgo:has(INV_SIX_PACK) ) ) and (> beersLeft 0) )
                Print("You don't have any beer to drink!")
                return(TRUE)
            )
            (++beersDrank)
            (--beersLeft)
            (switch (beersDrank)
              (case 1
                Print("Whoo! That beer really hit the spot. You feel a little tipsy though, might not want to drink anymore...")
                //Nothing happens after one drink
                (send gGame:changeScore(beersDrank))
                return (TRUE)
              )
              (case 2
                //Now you're drunk
                (send gGame:changeScore(beersDrank))
                Print("Wow, that beer really did something to you, you're quite dizzy and disoriented!")
              )
              (case 3
                (send gGame:changeScore(beersDrank))
                Print("The beer is getting you quite drunk, you don't think you should drink anymore")
              )
              (case 4
                Print("That fourth beer really hit the spot... You're feeling... Very... Awful...")

                = dyingScript ScriptID(DYING_SCRIPT)
                (send dyingScript:
                caller(3)
                register("You died from over intoxication! Next time don't drink so much!!")
                    )
                (send gGame:setScript(dyingScript))
                return(FALSE)

              )
                (default
                Display("." dsCOLOR clWHITE)
                )

            )

            = Drunk 1
        //Drunk handler - I don't know how the timer starts
            (= endDrink (+ GetTime(gtTIME_OF_DAY) (* beersDrank 5)))
            
            (User:
     		canControl(FALSE)
            )
            (send gEgo:setMotion(Wander))
            SetUpActor(gEgo (send gEgo:loop) 1)
            //Let ego wander around for awhile
            (while(< GetTime(gtTIME_OF_DAY) (endDrink))
                (super:doit())
                Wait(4)
            )

            //Drunk handler clear
            (User:
     		canControl(TRUE)
            )
            (send gEgo:setMotion(NULL))
            SetUpActor(gEgo (send gEgo:loop) 0)
            (= Drunk 0)
        )
        //Handle some general actions with the radio
        (if(Said('use/disc/radio'))
            (if ((send gEgo:has(INV_BARRY_WHITE)) and (send gEgo:has(INV_BOOM_BOX)))
                (if (== cdInRadio 0)
                    Print("You put the Barry White CD into the radio")
                    = cdInRadio 1
                    (send gGame:changeScore(4))
                )
                (else
                    Print("The CD is already in the radio")
                )
            )
            (else
                Print("You don't have that!!")
            )
        )
        
        (if(Said('play,use/radio'))
            (if (send gEgo:has(INV_BOOM_BOX))
                (if (== cdInRadio 0)
                    Print("This radio will only play compact discs, and there isn't one inside")
                )
                (else
                //Initial state of the radio or the state after you turned it off
                        Print("Your radio starts playing the music of love... but nothing happens so you turn it off" )
                )
            )
        )
        
        (if(Said('throw/beer'))
            Print("You don't want to toss a beer around for no reason")
        )
        //Now we handle the hints!
        (if(Said('hint'))
        (switch hintCounter
            (case 0
                Print("Yea right, like it's that easy, you just ask for helping hints and I'll give them to you. Why don't you try solving the adventure.")
                ++hintCounter
            )
            (case 1
                Print("Hmm, back again, kinda persistant aren't you? There's still no hints! Figure it out on your own!")
                ++hintCounter
            )
            (case 2
                Print("Okay, you must really need help, so heres some hints (Read them carefully, I'll only say them once")
                Print("Get all of the posters in the first room, they have hints on them too. Type 'TAKE CARMEN' or whoever you want to get. 'LOOK WALL' to see who is there")
                Print("Okay, that should help you out! Remember to DANCE in the first room on the obvious place. You need this to UNLOCK the beer, do your best to avoid the bear")
                ++hintCounter
            )
            (case 3
                Print("Okay, okay! You're really stumped. Remember, you're a PITCHER, and you have throwable BEERS! So start throwing them!")
                Print("Also, the point is to get the girls back into the hot chicks room. The magic mirror serves this purpose. Type 'USE MIRROR ON GIRL'")
                Print("You have to do some things before you can get some of girls though. The posters tell you.")
                ++hintCounter
            )
            
            (case 4
                Print("It should all be clear by now. THROW BEER AT BEAR, CLIMB TREE, THROW BEER AT GIRL. Wake up the girl in bed with the CD you find by playing the message on the answering machine.")
                Print("What else is left?? If you can't finish it now, then there's nothing more I can help you with")
                Print("Oh, getting a perfect score is up to the true adventurers! Remember you have 6 beers and you should use every one of them!")
                ++hintCounter
            )
            (case 5
                Print("There's no more hints! You should be seeing the end game message instead of this now!")
                ++hintCounter
            )
            (case 6
                Print("You better not ask for any more hints, because I don't have any good ones left. Did you remember reading the hint to save often? Probably a good idea.")
                ++hintCounter
            )
            
            case (7
                = dyingScript ScriptID(DYING_SCRIPT)
 	            (send dyingScript:
                    caller(003) //the mauled bear view is displayed for the death icon when you call with 260
                    register("Since you're so far lost, I'll just save you the effort and end the game for you now...")
                )
                (send gGame:setScript(dyingScript))
            )
        )
        )
        
        
        
        
		return(FALSE)
  	)
)

/******************************************************************************/
(class Iitem of InvI
	(properties
		said 0
		description 0
		owner 0
		view 0
		loop 0
		cel 0
		script 0
	)
	(method (showSelf)
		Print(
            description
			#title objectName
			#icon view 0 0
		)
	)
)
/******************************************************************************/
(instance statusCode  of Code
	(properties)
 	(method (doit param1)
  		Format(param1 " Score: %d of %-3d                      HCRA " gScore gMaxScore)
 	)
)
/******************************************************************************/
(instance ego of Ego
	(properties
		y 1111
		x 0
		z 0
		heading 0
		yStep 2
		view 0
		loop 0
		cel 0
		priority 0
		underBits 0
		signal $2000
		nsTop 0
		nsLeft 0
		nsBottom 0
		nsRight 0
		lsTop 0
		lsLeft 0
		lsBottom 0
		lsRight 0
		brTop 0
		brLeft 0
		brBottom 0
		brRight 0
		cycleSpeed 0
		script 0
		cycler 0
		timer 0
		illegalBits $8000
		xLast 0
		yLast 0
		xStep 3
		moveSpeed 0
		blocks 0
		baseSetter 0
		mover 0
		looper 0
		viewer 0
		avoider 0
		edgeHit 0
	)
)
/******************************************************************************/
(instance scoreSound of Sound
	(properties
		state 0
		number SCORE_SOUND
		priority 10
		loop 1
		handle 0
		signal 0
		prevSignal 0
		client 0
		owner 0
	)
)
/******************************************************************************/
(instance theMusic  of Sound
	(properties
		state 0
		number 1
		priority 0
		loop 1
		handle 0
		signal 0
		prevSignal 0
		client 0
		owner 0
	)
)
/******************************************************************************/
(instance theSoundFX  of Sound
	(properties
		state 0
		number 1
		priority 5
		loop 1
		handle 0
		signal 0
		prevSignal 0
		client 0
		owner 0
	)
)
/******************************************************************************/
(instance theWindow  of SysWindow
	(properties)
	(method (open)
		(if(< Graph(grGET_COLOURS) 9)
			(if( (< color 7) or (== color 8) )
				= color 0
				= back  15
			)(else
				= color 15
				= back  0
			)
  		)
  		(super:open())
	)
)
/******************************************************************************/
(instance NormalBase of Code
	(properties)
	(method (doit)
		(var temp0)
		(if(== gRoomNumberExit 253)
		    = temp0 22
		)(else
  			= temp0 10
		)
		(send gEgo:
			brBottom(
				(+ (send gEgo:y) 1)
			)
		)
		(send gEgo:
			brTop(
				(- (send gEgo:brBottom) (send gEgo:yStep))
			)
		)
		(send gEgo:
			brLeft(
				(- (send gEgo:x) temp0)
			)
		)
		(send gEgo:
			brRight(
				(+ (send gEgo:x) temp0)
			)
		)
	)
)

/******************************************************************************
 * THE PUBLIC PROCEDURES
 ******************************************************************************/
(procedure public (SetUpEgo theLoop theView)
	PlayerControl()
	(send gEgo:edgeHit(EDGE_NONE))
	(switch(paramTotal)
		(case 0
			SetUpActor(gEgo (send gEgo:loop) gEgoView)
		)
  		(case 1
			SetUpActor(gEgo theLoop gEgoView)
		)
  		(case 2
		    SetUpActor(gEgo theLoop theView)
  		)
	)
)
/******************************************************************************/
(procedure public (SetUpActor pActor theLoop theView)
	(if(> paramTotal 1)
		(send pActor:loop(theLoop))
	)
	(if(> paramTotal 2)
		(send pActor:view(theView))
	)
	(send pActor:
		setLoop(-1)
		setPri(-1)
		setStep(3 2)
		setCycle(Walk)
		illegalBits($8000)
		cycleSpeed(0)
		moveSpeed(0)
		ignoreActors(0)
	)
)
/******************************************************************************/
(procedure public (ProgramControl)
	(User:
		canControl(FALSE)
		canInput(FALSE)
	)
	(send gEgo:setMotion(NULL))
)
/******************************************************************************/
(procedure public (PlayerControl)
	(User:
		canControl(TRUE)
		canInput(TRUE)
	)
	(send gEgo:setMotion(NULL))
)
/******************************************************************************/
(procedure public (DisposePrintDlg)
	(if(gPrintDlg)
		(send gPrintDlg:dispose())
	)
)
/******************************************************************************/
(procedure public (PrintOK)
	Print("O.K.")
)
/******************************************************************************/
(procedure public (PrintItIs)
	Print("It is.")
)
/******************************************************************************/
(procedure public (PrintYouAre)
	Print("You are.")
)
/******************************************************************************/
(procedure public (PrintGoodIdea)
	Print("Good idea. You might try that again later.")
)
/******************************************************************************/
(procedure public (PrintNotCloseEnough)
	Print("You're not close enough.")
)
/******************************************************************************/
(procedure public (PrintAlreadyTookIt)
	Print("You already took it.")
)
/******************************************************************************/
(procedure public (PrintDontHaveIt)
	Print("You don't have it.")
)
/******************************************************************************/
(procedure public (PrintCantDoThat mem)
	(if(> MemoryInfo(miLARGESTPTR) mem)
		return(TRUE)
	)(else
		Print("You can't do that here; at least, not now.")
		return(FALSE)
	)
)
/******************************************************************************/
(procedure public (AddViewToPic pView)
	(var hView)
	(if(pView)
		= hView (View:new())
		(send hView:
		  	view(send pView:view)
			loop(send pView:loop)
			cel(send pView:cel)
			priority(send pView:priority)
			posn( (send pView:x) (send pView:y) )
			addToPic()
		)
		(send pView:
			posn( (send pView:x) (+ 1000 (send pView:y)) )
		)
	)
)
/******************************************************************************/
(procedure public (SetInvIOwner index owner)
	(var hInvI)
	= hInvI (send gInv:at(index))
	(if(< paramTotal 2)
		(send hInvI:owner(gRoomNumberExit))
	)(else
		(send hInvI:owner(owner))
	)
)


/******************************************************************************
 * THE INVENTORY ITEMS                                                        *
 ******************************************************************************/
(instance Nothing  of Iitem
	(properties)
)
/******************************************************************************/

(instance {Carmen Picture} of Iitem
	(properties
		said 'carmen'
		description
             "This is a picture of Carmen. She is a blonde and has a green shirt on in the picture. Theres seom writing on the back: Carmen is vain and loves to look at herself!"
		owner 0
		view 120
		loop 0
		cel 0
		script 0
	)
)

(instance {Emma Picture} of Iitem
	(properties
		said 'emma'
		description
             "This is a picture of Emma.  She is pale white, has blonde hair and is wearing a red hat in the picture. There's some writing on the back: Emma gets very dizzy after only a single beer."
		owner 0
		view 122
		loop 0
		cel 0
		script 0
	)
)

(instance {Ana Picture} of Iitem
	(properties
		said 'ana'
		description
             "This is a picture of Ana. She is a tanned blonde and is wearing a blue shirt. Ana wakes every morning to the sounds of Love."
		owner 0
		view 121
		loop 0
		cel 0
		script 0
	)
)

(instance {Six Pack} of Iitem
	(properties
		said 'beer'
		description
             "You've got the beer! Whohoo! Theres a Warning on the side ('Consumption of beer may be hazardous to your health')\n"+
             "Note: There may not really be six beers left, but you're sure you'll have enough!"
		owner 0
		view 201
		loop 0
		cel 0
		script 0
	)
)

(instance {Hot Chicks Room Key} of Iitem
	(properties
		said 'key'
		description
             "This is the key to the hot chicks room."
		owner 0
		view 131
		loop 0
		cel 0
		script 0
	)
)
(instance {Magic Mirror} of Iitem
	(properties
		said 'mirror'
		description
             "Looking into this mirror, you can see the Hot Chicks Room! You think you can USE it to get the girls back into the hot chicks room!"
		owner 0
		view 203
		loop 0
		cel 0
		script 0
	)
)
(instance {Beer Key} of Iitem
	(properties
		said 'key'
		description
             "This is a key that says BEER on it."
		owner 0
		view 130
		loop 0
		cel 0
		script 0
	)
)
(instance {Radio} of Iitem
	(properties
		said 'radio'
		description
             "This Radio looks like it can really pump out the rock hard grooves or sensual love tunes"
		owner 0
		view 200
		loop 0
		cel 0
		script 0
	)
)
(instance {Barry White Greatest Hits CD} of Iitem
	(properties
		said 'cd'
		description
             "This is the Barry White All Time Greatest Hits CD, guaranteed to get your women in 'the mood'"
		owner 0
		view 135
		loop 0
		cel 0
		script 0
	)
)


/******************************************************************************/

