/******************************************************************************
 SCI Template Game
 By Brian Provinciano
 ******************************************************************************
 titlescreen.sc
 Contains the title screen room.
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script TITLESCREEN_SCRIPT)
/******************************************************************************/
(use "main")
(use "game")
(use "menubar")
(use "obj")
(use "cycle")
(use "user")
(use "controls")
(use "feature")

(
    local animfin = 0
)
/******************************************************************************/
(instance public TitleScreen of Rm
	(properties
		picture scriptNumber
	)
	(method (init)
        // Set up the title screen
		ProgramControl()
		= gProgramControl FALSE

        (send gGame:setSpeed(6))
		(SL:disable())
		(TheMenuBar:hide())

		(super:init())
		(self:setScript(RoomScript))

		(send gEgo:
			init()
			hide()
		)

        /****************************************
         * Set up the room's music to play here *
         ****************************************/ /*
		(send gTheMusic:
			prevSignal(0)
			stop()
			number(scriptNumber)
			loop(-1)
			play()
		)       */
        (bear:
            init()
            setCycle(Walk)
            setMotion(MoveTo 150 180 RoomScript)
        )

        (myEgo:
            init()
            setCycle(Walk)
        )

        /**************************************************
         * Add the rest of your initialization stuff here *
         **************************************************/
		Display(
			"The Hot Chicks Room Adventure"
			dsCOORD 0 10
			dsCOLOUR clWHITE
			dsBACKGROUND clTRANSPARENT
		)
        Display(
            "Plot and Art by Matthew Jones & Chris Sauerwald"
			dsCOORD 0 20
			dsCOLOUR clWHITE
			dsBACKGROUND clTRANSPARENT
        )

        Display(
            "University of Michigan Dearborn - CIS 487/587"
			dsCOORD 0 30
			dsCOLOUR clWHITE
			dsBACKGROUND clTRANSPARENT
        )
        Display(
            "Written in SCI Studio by Brian Provinciano"
			dsCOORD 0 40
			dsCOLOUR clWHITE
			dsBACKGROUND clTRANSPARENT
        )
        Display(
            "Inspired by Upright Citizens Brigade Episode #1"
			dsCOORD 0 50
			dsCOLOUR clWHITE
			dsBACKGROUND clTRANSPARENT
        )
        Display("Additional inspiration from: homestarrunner.com"
            dsCOORD 0 60
            dsCOLOUR clWHITE
            dsBACKGROUND clTRANSPARENT
        )
        
        Display("Special thanks to all Sierra game creators"
            dsCOORD 0 70
            dsCOLOUR clWHITE
            dsBACKGROUND clTRANSPARENT
        )
        
        Display(
            "'Some of the Chicks aren't so hot anymore,"
			dsCOORD 0 90
			dsCOLOUR clWHITE
			dsBACKGROUND clTRANSPARENT
        )
        Display(
            "but they are replaceable.' - UCB"
			dsCOORD 0 100
			dsCOLOUR clWHITE
			dsBACKGROUND clTRANSPARENT
        )


	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)     /*
    (method (changeState newState)
        = state newState
        /************************************
         * Add the state related stuff here *
         ************************************/
    //)

    (method (changeState newState)
        = state newState
    //This is the sequence of the little intro animation that plays on the bottom
    //Of the screen
    (switch (state)
        (case 0
            = cycles 1
        )
        (case 1

        )
        (case 2
            Display("Eeep!!"
                    dsCOLOUR clWHITE
                    dsCOORD 40 120
            )
            (myEgo:setMotion(MoveTo 10 180 RoomScript))
            (bear:setMotion(MoveTo 10 180 RoomScript))
        )
        (case 3
            Display("Eeep!!"
                    dsCOLOUR clBLACK
                    dsCOORD 40 120
            )
            myEgo:hide()
        )
        (case 4
            Display("Click the button or press enter to continue!"
            dsCOORD 20 180
            dsCOLOUR clRED
            )
            = animfin 1
            bear:hide()
        )

    )
    )

	(method (handleEvent pEvent)
        (super:handleEvent(pEvent))
        (if( not (send pEvent:claimed) )
			(if( (== (send pEvent:type) evKEYBOARD) and (== (send pEvent:message) $3C00) )
				ToggleSound()
			)(else
                /******************************************
                 * If the title screen has music, fade it *
                 ******************************************/
				//(send gTheMusic:fade())
                (if (animfin)
                // End the title screen, start the game
				    (send gRoom:newRoom(INITROOMS_SCRIPT))
                )
		    )
		)
	)
)
/******************************************************************************/

(instance bear of Act
    (properties
        x 280
        y 180
        view 259
    )
)

(instance myEgo of Act
    (properties
        x 50
        y 180
        view 0
    )
)
