//SCI Script for room #1 - Hot Chicks Room
//Written by Matthew Jones (jonespm@umich.edu)
//Written for CIS 487/587 - University of Michigan Dearborn
//October 2002

/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 100)
/******************************************************************************/
(use "controls")
(use "cycle")
(use "door")
(use "feature")
(use "game")
(use "inv")
(use "main")
(use "obj")
(use "dpath")
(use "wander")
(use "user")

/******************************************************************************/

(instance public rm100 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
	(method (init)
		(super:init())
		(self:setScript(RoomScript))

		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(70 136)
					loop(0)
				)
			)
		)

		SetUpEgo()
        //DEBUG CODE
        //(send gEgo:get(INV_SIX_PACK))
        
        //If its the first time here, print some stuff you need this key to get out of the room.
        (if (not (send gEgo:has(INV_HCR_KEY)))
            Print("Hello! Welcome adventurer! I'm here to give you a few hints before you get started.\n")
            Print("First off, as in all adventures pick up everything you can that isn't nailed down.\n"+
                  "This is the standard rule of all adventure games. Pressing the TAB key will also bring up your inventory.")
            Print("Secondly, you CAN die, so be careful and save so you don't have to repeat anything! (Saving is on the menu)")
            Print("Lastly, there are hints around, if you can find them, they might help! Remember to READ EVERYTHING! Enjoy!")
            Print("By the way: You are named Miles and you own this house and have a GREAT pitching arm. The Hot Chicks Room was installed by the previous owner, but you kept it. You just woke up after having a dream of being chased by a huge bear and notice that all of the girls are gone! You need to get them back and find out what happened.")
        
        )
		(send gEgo:init())
         //Initialization stuff for the lights
         //The lights are supposed to wander around on the wall
         (Light1:init()
         setCycle(Walk)
         ignoreActors()
         //Starts at 100,50
         setMotion(Wander)
        )
        
        //Starts at 125,30
        (Light2:init()
         setCycle(Walk)
         ignoreActors()
         setMotion(Wander)
        )
        //Starts at 150,10
        (Light3:init()
         setCycle(Walk)
         ignoreActors()
         setMotion(Wander)
        )
        
        //Now start up the floor lights
        //The floor lights cycle to different colors
        (FloorLight1:
            init()
            setCycle(Fwd)
            ignoreActors()
            setPri(0)
            cycleSpeed(1)
        )

        (FloorLight2:
            init()
            setCycle(Fwd)
            ignoreActors()
            setPri(0)
            cycleSpeed(1)
        )
        (FloorLight3:
            init()
            setCycle(Fwd)
            ignoreActors()
            setPri(0)
            cycleSpeed(1)
        )

        (FloorLight4:
            init()
            setCycle(Fwd)
            ignoreActors()
            setPri(0)
            cycleSpeed(1)
        )
        (FloorLight5:
            init()
            setCycle(Fwd)
            ignoreActors()
            setPri(0)
            cycleSpeed(1)
        )
        (FloorLight6:
            init()
            setCycle(Fwd)
            ignoreActors()
            setPri(0)
            cycleSpeed(1)
        )
        (FloorLight7:
            init()
            setCycle(Fwd)
            ignoreActors()
            setPri(0)
            cycleSpeed(1)
        )
        (FloorLight8:
            init()
            setCycle(Fwd)
            ignoreActors()
            setPri(0)
            cycleSpeed(1)
        )
        (FloorLight9:
            init()
            setCycle(Fwd)
            ignoreActors()
            setPri(0)
            cycleSpeed(1)
        )

    //Pictures of the girls, place them if you don't already have them
        (if(not (send gEgo:has(INV_CARMEN_POSTER)))
        (CarmenPic:
            init()
        )
        )

        (if(not (send gEgo:has(INV_ANA_POSTER)))
        (AnaPic:
            init()
        )
        )
        
        (if(not (send gEgo:has(INV_EMMA_POSTER)))
        (EmmaPic:
            init()
        )
        )
    //Init the Door
    (lDoor:init())
    //If the girls are in the room, draw them, if they are all in the room, put the secret note
    (if (==gotAllGirls 1)
        (= readEndNote 1)
        Print("Oh no! Just when you think you'd gotten them all back into the room "+
              "the room is empty! You find a note which reads:\n\n"+
              "I have all of the girls again, come to the clifftop to get them.\n"+
              "Signed, Bear")

    )

    (if((== gotEmma 1) and (== gotAllGirls 0))
        (emmaDance:
            init()
        )
    )
    (if((== gotCarmen 1) and (== gotAllGirls 0))
        (carmenDance:
            init()
        )
    )
    
    (if((== gotAna 1) and (== gotAllGirls 0))
        (anaDance:
            init()
        )
    )
    
	)   //End of room init
)

//Defines the posters that are left in the room
(string postersleft[100])

/******************************************************************************/
(instance RoomScript of Script

	(properties)
    //This is the dance handler!
    (method (changeState newState)
        = state newState
    (switch (state)
        (case 0
        = cycles 1
        //Print("0")
        )
        (case 1
        //Print("1")
        )
        (case 2
        //Print("2")
            (send gEgo:setMotion(MoveTo(170 150 RoomScript)))
        )
        (case 3
            (send gEgo:setMotion(MoveTo(200 140 RoomScript)))
        )
        (case 4
            Print("While dancing on the broken light you knock out a key (which you take). It is labeled BEER!")
            (User:canControl(TRUE))

            (send gGame:changeScore(3))
            (send gEgo:get(INV_BEER_KEY))
             SetUpActor(gEgo (send gEgo:loop) 0)
        )
    )
    )
    
	(method (handleEvent pEvent)

        //Posters that are left in the room

        (var numposters,beerx,beery)

        (super:handleEvent(pEvent))
        =numposters 0
        
        StrCpy(postersleft "")
        
        //Figure out the posters that are left on the wall
        (if(not(send gEgo:has(INV_CARMEN_POSTER)))
            StrCat(postersleft "Carmen ")
            = numposters (+ numposters 1)
        )

        (if(not(send gEgo:has(INV_ANA_POSTER)))
            StrCat(postersleft "Ana ")
            = numposters (+ numposters 1)
        )
        
        (if(not(send gEgo:has(INV_EMMA_POSTER)))
            StrCat(postersleft "Emma ")
            = numposters (+ numposters 1)
        )
        
        (if (== numposters 0)
            StrCpy(postersleft("nobody!"))
        )

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/

        //Handle all of the looking first
        (if(Said('look/wall,poster,poster'))
            FormatPrint(("Against the wall you see %d poster(s). From left to right you see %s" numposters postersleft ))

        )
        (if(Said('look/light'))
            Print("There are moving lights along the wall, they just seem to be there for entertainment.")
        )
        (if(Said('look/floor'))
            Print("There is a flashing dance floor in this room."+
                  "You think that you notice that one of the dance tiles is partially cracked")
        )
        
        (if(Said('look/tile'))
            Print("Yup, it's definately a cracked tile!")
        )
        //Generic look
        (if(Said('look/carmen'))
            (if ((== gotCarmen 1) and (== gotAllGirls 0))
                Print("Carmen is just hanging out by the wall right now")
            )
            (else
                (if (send gEgo:has(INV_CARMEN_POSTER))
                    Print("You have the poster in your inventory")
                )
                (else
                    Print("There is a poster of carmen on the left side of the back wall")
                )
            )
        )
        
        (if(Said('look/emma'))
            (if ((== gotEmma 1) and (== gotAllGirls 0))
                Print("Emma is here, waiting for the party to start!")
            )
            (else
                (if (send gEgo:has(INV_EMMA_POSTER))
                    Print("You have the poster in your inventory")
                )
                (else
                    Print("There is a poster of Emma on the right side of the back wall")
                )
            )
        )
        
        (if(Said('look/ana'))
            (if ((== gotAna 1) and (== gotAllGirls 0))
                Print("Ana looks like she's still waking up from her sleep")
            )
            (else
                (if (send gEgo:has(INV_ANA_POSTER))
                    Print("You have the poster in your inventory")
                )
                (else
                    Print("There is a poster of Ana on the middle of the back wall")
                )
            )
        )
        
        (if(Said('look'))
            Print("You are in THE hot chicks room. There are lights moving all around the room and "+
                   "a flashing dance floor. On a normal day this place is full of girls partying. "+
                   "There is a door on the one wall of the room")
        )


        //Handle item taking
        //Handle trying to take carmens picture
        (if(Said('take/picture/carmen') or Said('take/carmen') )
            (if(send gEgo:has(INV_CARMEN_POSTER))
                Print("You already have it!")
            )(else
              (if(send gEgo:inRect(90 90 120 140))
                Print("You remove the poster of Carmen with no problems. Also a key falls out which you also take.")
                (send gGame:changeScore(3))
                (send gEgo:get(INV_CARMEN_POSTER))
                (send gEgo:get(INV_HCR_KEY))
                (CarmenPic:hide())
              )(else
              Print("You're not close enough!")
             )
         )
        )
        
        //Handle trying to take ana's picture
       (if(Said('take/picture/ana') or Said('take/ana'))
            (if(send gEgo:has(INV_ANA_POSTER))
                Print("You already have it!")
            )(else
              (if(send gEgo:inRect(160 90 180 140))
                Print("You remove the poster of Ana with no problems")
                (send gGame:changeScore(3))

                (send gEgo:get(INV_ANA_POSTER))
                (AnaPic:hide())
              )(else
              Print("You're not close enough!")
             )
         )
        )
        
        //Handle trying to take emma's picture
        (if(Said('take/picture/emma') or Said('take/emma') )
            (if(send gEgo:has(INV_EMMA_POSTER))
                Print("You already have it!")
            )(else
              (if(send gEgo:inRect(210 90 230 140))
              
              //Check the puzzle here
                (if (== usedBeerOnPoster 1)
                    Print("You remove the poster of Emma with no problems")
                    (send gGame:changeScore(2))
                    (send gEgo:get(INV_EMMA_POSTER))
                    (EmmaPic:hide())
                )
                (else
                    Print ("The poster is stuck to the wall with some kind of really sticky paste. "+
                           "You're going to need something to loosen this up.")
                )
              )(else
              Print("You're not close enough!")
             )
         )
        )

        //Handle the beer trick to get emmas picture and taking it
        (if(Said('pour,use/beer/emma,picture'))
            (if(send gEgo:has(INV_SIX_PACK))

                (if((send gEgo:has(INV_EMMA_POSTER)) or (== usedBeerOnPoster 1))
                    Print("You already already did that!")
                )
                (else
                    (if(send gEgo:inRect(210 90 230 140))
                    Print("You pour the beer on the poster, it removes all of the paste.")
                    (send gGame:changeScore(1))
                    = usedBeerOnPoster 1
                    )
                )
            )
           (else
                Print("You don't have the beer")
            )
        )
        //Picture taker
        (if (Said('take/picture'))
            Print("Which picture do you want to take?")
        )
        //Handle the door
        (if(Said('open/door'))
        //HCR KEY opens the door

          (if(send gEgo:has(INV_HCR_KEY))
              (lDoor:locked(FALSE))
          )(else
              (lDoor:locked(TRUE))
        )

            (lDoor:open())
        )

        //Now handle the tile and dancing
        (if(Said('dance') or Said('break'))
        //Check to see if the player is by the broken tile
            (if(send gEgo:inRect(170 130 220 150))
                (if (not (send gEgo:has(INV_BEER_KEY)))
                    Print ("You start to dance on the broken tile!")
                    (User:canControl(FALSE))
                     SetUpActor(gEgo (send gEgo:loop) 1)
                    (send gEgo:setMotion(MoveTo(220 130 RoomScript)))
                )
                (else
                    Print("You already have danced and got the key, no more dancing for you.")
                )
            )
            (else
                Print("While you love to dance, you really don't want to do it without a purpose.")
            )
        )

        (if(Said('talk/carmen'))
            (if ((== gotCarmen 1) and (== gotAllGirls 0))
                Print("I can't hear you! The music is too loud!")
            )
            (else
                Print("You're not talking to the poster")
            )
        )

        (if(Said('talk/emma'))
            (if ((== gotEmma 1) and (== gotAllGirls 0))
                Print("When is everyone arriving!?")
            )
            (else
                Print("You're not talking to the poster")
            )
        )

        (if(Said('talk/ana'))
            (if ((== gotAna 1) and (== gotAllGirls 0))
                Print("WHOOOOO!! PARTY!!")
            )
            (else
                Print("You're not talking to the poster")
            )
        )
        
 	)
)

/******************************************************************************/
//Set up all of the wall lights
(instance Light1 of Act
    (properties
        x 100
        y 50
        view 400
    )
    (method (moveDone)
		(self:init())
	)
)

(instance Light2 of Act
    (properties
        x 125
        y 30
        view 400
        loop 1
     )
    (method (moveDone)
        (self:init())
	)
)
(instance Light3 of Act
    (properties
        x 150
        y 10
        view 400
        loop 2
     )
     (method (moveDone)
		(self:init())
     )
)

//Setup the 9 floor lights
(instance FloorLight1 of Prop
    (properties
        x 110
        y 153
        view 102
    )
)

(instance FloorLight2 of Prop
    (properties
        x 110
        y 143
        view 100
     )
)
(instance FloorLight3 of Prop
    (properties
        x 110
        y 133
        view 101
     )
)
(instance FloorLight4 of Prop
    (properties
        x 160
        y 153
        view 100
    )
)

(instance FloorLight5 of Prop
    (properties
        x 160
        y 143
        view 101
     )
)
(instance FloorLight6 of Prop
    (properties
        x 160
        y 133
        view 103
     )
)
(instance FloorLight7 of Prop
    (properties
        x 210
        y 153
        view 103
    )
)

//Cracked Floor
(instance FloorLight8 of Prop
    (properties
        x 210
        y 143
        view 104
     )
)

//Regular floor again
(instance FloorLight9 of Prop
    (properties
        x 210
        y 133
        view 100
     )
)

//Pictures of the girls
(instance CarmenPic of Prop
    (properties
        x 100
        y 90
        view 120
     )
)
(instance AnaPic of Prop
    (properties
        x 170
        y 90
        view 121
    )
)

(instance EmmaPic of Prop
    (properties
        x 220
        y 90
        view 122
    )
)

//Ana if she is in the room
(instance anaDance of Act
    (properties
        x 100
        y 119
        view 190
    )
)

//Carmen if she is in the room
(instance carmenDance of Act
    (properties
        x 150
        y 119
        view 191
    )
)
//Emma if she is in the room
(instance emmaDance of Act
    (properties
        x 200
        y 119
        view 192
    )
)

//Room Door unlocked for testing
(instance lDoor of Door
  (properties
    x 52
    y 146
    view 110
    entranceTo 101
    locked TRUE
  )
)
