//SCI Script for room #1 - Hot Chicks Room
//Written by Matthew Jones (jonespm@umich.edu)
//Written for CIS 487/587 - University of Michigan Dearborn
//October 2002

/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 101)
/******************************************************************************/
(use "controls")
(use "cycle")
(use "door")
(use "feature")
(use "game")
(use "inv")
(use "main")
(use "obj")
(
    //To indicate whether you talked to Carmen or not
    local talkedCarmen = 0
)
/******************************************************************************/
(instance public rm101 of Rm
	(properties
		picture scriptNumber
		north 200
		east 0
		south 0
		west 0
	)

    //Will handle walking into the bedroom
    (method (doit)
       (if(== (send gEgo:onControl(ocSPECIAL)) $0200)
         (send gRoom:newRoom(102))
       )
    )


	(method (init)
        //Change the north room so we can skip it (If they have the boombox)
        (var nRm)
        //To help out the player and warm him
        (if (send gEgo:has(INV_BOOM_BOX))
            = nRm 201
        )
        (else
            = nRm 200
        )
		(super:init())
        
		(self:setScript(RoomScript))
		(switch(gPreviousRoomNumber)
            (case 100
            (send gEgo:
					posn(270 105)
					loop(1)
				)
			)
            (case 102
            (send gEgo:
                    posn(100 110)
                    loop(0)
                )
            )
            (case 201
                (send gEgo:
                    posn(205 82)
                    loop(2)
                )

            )
            (case north
            (send gEgo:
                    posn(205 82)
                    loop(2)
                )
            )
            (default
				(send gEgo:
					posn(270 105)
					loop(1)
				)
			)
		)
  
        //Help out the player
        (if ((== cliffWarp 0) and (send gEgo:has(INV_BOOM_BOX)))
            Print("You were getting tired of walking up and down that path, so you'll take a shortcut next time!")
            =cliffWarp 1
        )
        
		SetUpEgo()
		(send gEgo:init())

        //If we haven't gotten carmen yet
        (if (== gotCarmen 0)

            (hotTub:
                init()
                setCycle(Fwd)
                setPri(8)
                cycleSpeed(1)
                setLoop(0)
            )

        )
        (else

            (hotTub:
                init()
                setLoop(1)
            )
            
        )

        //If the message hasn't been played, make it blink, otherwise do nothing
        (if(== messagePlayed 0)
            (table:
                init()
                setCycle(Fwd)
                cycleSpeed(1)
            )
        )
        (else
            (table:
               init()
            )
        )
        //Set where the north door will lead to
        (nDoor:
            setEntrance(nRm)
            init()
        )
        //The right door always leads to the same place
        (rDoor:init())
	)
)

/******************************************************************************/
(instance RoomScript of Script
	(properties)
    (method (handleEvent pEvent)
        //First handle all of the look actions

        (if(Said('look/answering,machine'))
            (if(== messagePlayed 0)
                Print("Hmm, appears as if you might have a message on there!")
            )
            (else
                Print("Its just an answering machine, no more messages on there")
            )
        )
        (if(Said('look/table'))
            Print("You see an ordinary table with an answering machine on it")
        )

        (if(Said('look/hot,tub'))
            Print("The warm waters of the hot tub look inviting, but you're not Earl, you have adventuring to do!")
        )
        
        (if(Said('look/carmen'))
            (if (== gotCarmen 0)
                Print("Ahh! The beautiful blonde Carmen is relaxing in the hot tub")
            )
            (else
                Print("Carmen isn't here!")
            )
        )

        (if(Said('look/door'))
            Print("There are two doors in this room. One of them leads back to the Hot Chicks Room."+
                  " The other door leads to your backyard.")
        )

        (if(Said('look/archway'))
            Print("Your bedroom lies beyond the arched doorway")

        )
        (if(Said('look/window'))
            Print("You see the beautiful blue sky out side of your house in the window")
        )
        
        (if(Said('look'))
            Print("You are in the living room. This is the main room of your house "+
                  "and the gateway to the great outdoors (And the hot chicks room)."+
                  "You see a table with phone and answering machine, two doors and an "+
                  "archway leading off to the west. You also notice that your living room now has "+
                  "a hot tub.")
        )
        
        //A use action that really doesn't work

        (if( (Said('use,swim,bathe/hot,tub')) or (Said('get<in<hot,tub')))
            Print("You really like your clothes and wouldn't want to get them wet")
        )


        //Now handle all of the take actions, check to make sure you don't have it yet
        (if(Said('take/carmen'))
            (if (== gotCarmen 0)
                Print("Carmen is not going to just come with you, you need to get her somehow")
            )
            (else
                Print("Carmen isn't here, and you couldn't take her even if she was!")
            )
        )

        (if(Said('take/table'))
            Print("The table is much too heavy for you to take, even though you are very strong.")
        )
        
        (if(Said('take/answering,machine'))
            Print("If you take it out of the wall, you will not be able to get messages from hot chicks!")
        )
        
        (if(Said('take/hot,tub'))
            Print("You couldn't possibly take the hot tub alone, it's massive!")
        )
        
        //Take the tape!
        (if(Said('take/tape'))
            (if( not (send gEgo:has(INV_BARRY_WHITE)))
                (if (> (send gEgo:distanceTo(table)) 40)
                    Print("Get closer to the table")
                )
                (else
                    (send gEgo:get(INV_BARRY_WHITE))
                    (send gGame:changeScore(2))
                    Print("You picked up the disc")
                )
            )
            (else
                Print("You already have it")
            )

        )
        
        (if(Said('take'))
            Print("What did you want to take?")
        )


        (if(Said('play,use/answering,machine,message'))
            (if (> (send gEgo:distanceTo(table)) 40)
                Print("Get closer to the table")
            )
            (else
                (if (== messagePlayed 1)
                    Print("There are no messages to play!")
                )
                (else
                  = messagePlayed 1
                    (send gGame:changeScore(2))
                    Print ("Strong Bad,\nMy sister and me think you are so cool. Do you have a girlfirend. there is two of us\nYours, Ali.")
                    Print("Message DELETED!")
                    Print("Well, the message was deleted, and it didn't seem to be for you anyway. You did notice a compact disc on the table while it was playing though.")
                    (table:
                        setCycle(NULL)
                    )
                )
                )
        )

        (if(Said('play'))
            Print("What did you want to play?")
        )

        //Handle the using the magic mirror on Carmen
        (if(Said('use/mirror/carmen,girl'))
            (if (== gotCarmen 1)
                Print("You already have Carmen!")
            )
            (else
                (if (send gEgo:has(INV_MAGIC_MIRROR))
                    (if (> (send gEgo:distanceTo(hotTub)) 40)
                        Print("Get closer!")
                    )
                    (else
                         = gotCarmen 1
                         (send gGame:changeScore(5))
                         Print("The Magic Mirror wisks Carmen off somewhere else")
                         (hotTub:
                            setLoop(1)
                        )
                    )
                )
                (else
                    Print("You don't have anything like that!")
                )
            )
        )

        //Talking to the girl
        (if(Said('talk/carmen,girl'))
            (if (== gotCarmen 1)
                Print ("She's not here to talk to.")
            )
            (else
                (if (== talkedCarmen 0)
                    Print("Don't bother me, I'm relaxing in this hot tub right now. I don't know how I or the hottub got here, but I've been partying for too long")
                    = talkedCarmen 1
                )
                (else
                Print("She just ignores you...")
                )
            )
        )

     //Have to check which door we are near and open the right one.
        (if(Said('open/door'))
          (if (nDoor:ison())
            nDoor:open()
          )
          (else
              (if(send gEgo:has(INV_HCR_KEY))
                (rDoor:locked(FALSE))
              )
              (else
                (rDoor:locked(TRUE))
              )
            (rDoor:open())
          )
        )

        //Close up the door
        (if(Said('close/door'))
            (if (nDoor:ison())
                nDoor:close()
            )

            (if (rDoor:ison())
                rDoor:close()
            )
        )
  )
)

/******************************************************************************/

//Initialize the hot tub around the beginning of the room
(instance hotTub of Door
  (properties
    x 156
    y 148
    view 150
  )
)

//Door on the north wall
(instance nDoor of Door
  (properties
    x 205
    y 72
    view 600
    entranceTo 200
//This door needs special control colors because we have two doors
    doorCtrl  $0010
    roomCtrl  $0008
    doorBlock $2000
    locked FALSE
  )
)

//Door on the right wall
(instance rDoor of Door
  (properties
    x 281
    y 105
    view 111
    entranceTo 100
    locked TRUE
  )
)

//Door on the north wall
(instance table of Prop
  (properties
    x 148
    y 75
    view 160
  )
)
