//SCI Script for room #1 - Hot Chicks Room
//Written by Matthew Jones (jonespm@umich.edu)
//Written for CIS 487/587 - University of Michigan Dearborn
//October 2002

/******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 102)
/******************************************************************************/
(use "controls")
(use "cycle")
(use "door")
(use "feature")
(use "game")
(use "inv")
(use "main")
(use "obj")
/******************************************************************************/

(instance public rm102 of Rm
	(properties
		picture scriptNumber
		north 0
		east 0
		south 0
		west 0
	)
 
    //The doit action will constantly check if you are leaving the room or
    //If you can wake up Ana
    (method (doit)
       (if(== (send gEgo:onControl(ocSPECIAL)) $0200)
         (send gRoom:newRoom(101))
       )
       (if ((== RadioOn 1) and (== gotAna 0))
            (if (== anaIsSleeping 1)
                Print("You radio wakes up Ana!")
                = anaIsSleeping 0
                bed:setLoop(1)
            )
        )
    )
    
    //You can only come from one room
	(method (init)

    //Sets the proper view for the bed
    (var bedView)

       (if (== gotAna 1)
            = bedView 2
       )
       (else
            (if (==anaIsSleeping 1)
                = bedView 0
            )
            //She has to be awake and here
            (else
                = bedView 1
            )
       )
       
		(super:init())
		(self:setScript(RoomScript))
		(switch(gPreviousRoomNumber)
			(default
				(send gEgo:
					posn(250 101)
					loop(1)
				)
			)
		)

		SetUpEgo()
		(send gEgo:init())
        //Setup the bed

        (bed:
            init()
            setCycle(Fwd)
            cycleSpeed(1)
            setLoop(bedView)
        )
        (monkeyPic:init())
        
	)
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
    (method (handleEvent pEvent)
        //Handle the look events, of the monkey
        (if(Said('look/picture,monkey'))
                Print("Ahh, your fine monkey picture. You have some fond memories "+
                       "of the monkey pictured, but you're on an important quest "+
                       "and can't spend time thinking about that right now.")
        )
        //Looking at the bed
        (if(Said('look/bed'))
            (if (== gotAna 1)
                Print("You see an empty bed!")
            )
            (else
                Print("You see Ana, she's on the bed")
            )
        )
        //Looking at ana
        (if(Said('look/girl,ana'))
            (if (== anaIsSleeping 1)
                Print("You see Ana on the bed, she is currently sound sleep.")
            )
            (else
                (if (== gotAna 0)
                    Print("You see Ana on the bed you did wake her up with that music, now you have her attention.")
                )
                (else
                    Print("Ana isn't here!")
                )
            )
        )
        (if(Said('look/under/bed'))
            Print("All you have are magazines down there. They won't help you in your quest")
        )
        (if(Said('look'))
                  Print("You are in the bedroom, you seem to be missing some things, but "+
                  "you are more concerned about finishing your quest than worry about that "+
                  "now. You still have your fine framed picture on the wall and your bed.")
        )

        //Handle all of the take actions
        (if(Said('get/girl,ana'))
            (if (== gotAna 0)
                Print("She won't just come with you, you'll need to try something else.")
            )
            (else
                Print("Ana isn't here!!")
            )
        )
        
        (if(Said('get/picture,monkey'))
            Print("The monkey picture is firmly attached to the wall. It really is just for decoration.")
        )
        
        (if(Said('get/bed'))
            Print("Theres no way you're taking the bed, even if you could fit it in your inventory.")
        )
        (if(Said('talk/ana,girl'))
            (if (== gotAna 1)
                Print ("She's not here to talk to")
            )
            (else
                (if (== anaIsSleeping 1)
                    Print("She's sleeping right now...")
                )
                (else
                Print("Well, you got me up, but now that I'm all rested all I want to do is go back to partying. (Dang! The music selection didn't seem to have the effect it is known for)")
                )
            )
        )
        
        (if(Said('wake/ana,girl'))
            Print("You try to wake her up but nothing you can do is working!")
        )
        
        (if(Said('play,use/radio'))
            (if (send gEgo:has(INV_BOOM_BOX))
                (if (== cdInRadio 0)
                    Print("This radio will only play compact discs, and there isn't one inside")
                )
                (else
                //Initial state of the radio or the state after you turned it off
                    (if (==RadioOn 0)
                        Print("Your radio starts playing the music of love...!")
                            (send gGame:changeScore(3))
                            =RadioOn 1
                    )
                    (else
                        ("You don't need to use the radio anymore.")
                    )
                    
                )
            )
            (else
                Print("You don't have that to play.")
            )
        )
        //Handle the special magic mirror event
        (if(Said('use/mirror/ana,girl'))
            (if (== gotAna 1)
                Print("You already have ana!")
            )
            (else
                (if (send gEgo:has(INV_MAGIC_MIRROR))
                    (if (> (send gEgo:distanceTo(bed)) 40)
                        Print("Get closer!")
                    )
                    (else
                        (if(== anaIsSleeping 1)
                            Print ("She's sleeping right now, you can't do that")
                        )
                        (else
                            = gotAna 1
                            (send gGame:changeScore(5))
                            Print("The Magic Mirror wisks Ana off somewhere else")
                              bed:setLoop(2)
                        )

                    )
                )
            )
        )
    )
)
/******************************************************************************/

//Door on the right wall
(instance monkeyPic of Prop
  (properties
    x 160
    y 50
    view 171
  )
)

(instance bed of Prop
  (properties
    x 110
    y 90
    view 173
  )
)
