/******************************************************************************
 Winding Path Script (rm200)
 Chris Sauerwald (csauerwa@umich.edu)
 CIS 487 Hot Chicks Room adventure.
 altered template script from SCI Studio.
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 200)
/******************************************************************************/
(use "main")
(use "controls")
(use "cycle")
(use "game")
(use "feature")
(use "obj")
(use "inv")
(use "door")
(use "jump")
(use "dpath")
/******************************************************************************/
(instance public rm200 of Rm
	(properties
		picture scriptNumber
		// Set up the rooms to go to/come from here
		north 201
		east  0
		south 101
		west 0
	)

    (method (doit)
        (if(== (send gEgo:onControl()) $2000)
          (send gRoom:newRoom(201))
        )
        (else
            super:doit()
        )
    )

	(method (init)
		// same in every script, starts things up
  		(super:init())
  		(self:setScript(RoomScript))

  		// Check which room ego came from and position it
  		(switch(gPreviousRoomNumber)
            (case 201
  				(send gEgo:
  					posn(210 20)
  					loop(2)
  				)
  			)

            (case 101
                (send gEgo:
                    posn(150 180)
                    loop(3)
                )
            )
            // Set up ego's position if it hasn't come from any room
  			(default
  				(send gEgo:
  					posn(150 175)
  					loop(1)
  				)
  			)
  		)


		// Set up the ego
		SetUpEgo()
		(send gEgo:init())
        (if (not (send gEgo:has(INV_BOOM_BOX)))
            (boombox:
                init()
            )
        )
    )
)
/******************************************************************************/
(string endOfPath[20])
(instance RoomScript of Script
	(properties)
	(method (handleEvent pEvent)
        (super:handleEvent(pEvent))
        StrCpy(endOfPath "")
        (if (not (send gEgo:has(INV_BOOM_BOX)))
            StrCat(endOfPath "a boombox and")
        )



        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
        (if ( Said('take/boombox,radio') )
            (if (send gEgo:has(INV_BOOM_BOX))
                Print("You already have the boom box.")
            )
            (else
                (if ( > (send gEgo:distanceTo(boombox)) 50)
                    Print("You are not close enough.")
                )
                (else
                    Print("You take the boombox.")
                    (send gGame:changeScore(3))
                    (send gEgo:get(INV_BOOM_BOX))
                    (boombox:hide())
                )
            )
        )

        (if (Said('look/boombox,radio') )
            Print("The boombox has a cd and tape player.")
        )

        (if (Said('look'))
            FormatPrint("You see a strange and seemingly out of place windy path here.  You may want to run through here.  Don't worry you can't fall off."+
                  "At the end of the path you see %s the cliff top." endOfPath)
        )
 	)
)

(instance boombox of Prop
    (properties
        x 150
        y 25
        view 200
    )
)
/******************************************************************************/
