/******************************************************************************
 Cliff top script (rm201)
 Chris Sauerwald (csauerwa@umich.edu)
 CIS 487 Hot Chicks Room adventure.
 altered template script from SCI Studio.
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 201)
/******************************************************************************/
(use "main")
(use "controls")
(use "cycle")
(use "game")
(use "feature")
(use "obj")
(use "inv")
(use "door")
(use "jump")
(use "dpath")
(use "wander")
(use "user")

/******************************************************************************/
(local
//some variables to help with the mauling and whether or not the beer is unlocked
//for now they are both set to one for development
    beerThrown=0
    endGame=0
    )
(string endscore[100]
        beertext[35]
        timetook[100]
)

(instance public rm201 of Rm

	(properties
		picture scriptNumber
		// Set up the rooms to go to/come from here
		north 0
		east 0
		south 200
		west 0
	)
    (method (doit)
        (var dyingScript)


         //(if(== (send gEgo:onControl()) $0800)
         (if ( < (send gEgo:distanceTo(bear) ) 30 )
            (if (== bearOut 0)
                = bearOut 1
                = dyingScript ScriptID(DYING_SCRIPT)
                //before calling the death script we put up the censored box and send the bear there
                (censor:
                    posn((send gEgo:x) (send gEgo:y))
                    show()
                    setPri(15)
                )
                (bear:
                    setMotion(MoveTo (send gEgo:x) (send gEgo:y))
                )
                (send dyingScript:
                    caller(260) //the mauled bear view is displayed for the death icon when you call with 260
                    register("You've just been mauled.... guess you should have tried to AVOID the bear.")
                )
                (send gGame:setScript(dyingScript))
            )

        )

        (if ( (< (send gEgo:distanceTo(mdoor)) 20) and (== endGame 0) and  (== readEndNote 1 ))
            //End of game sequence
            (send gEgo:hide())
            
            = endGame 1
            //Set up the strings!
            Format(endscore "You scored %d out of %-2d points" gScore gMaxScore)
            Format(timetook "You took %-2d hour(s) %-2d minute(s) %-2d second(s)" gTimeHours gTimeMinutes gTimeSeconds)

            Print("You get feel your body being pulled into another world...  Where has that bear taken the girls now!?")
            Wait(60)
            Display(
			     "You completed 'The Hot Chicks Room Adventure'"
			     dsCOORD 0 10
			     dsCOLOUR clWHITE
			     dsBACKGROUND clBLACK
            )
            Wait(180)
            Display(
                "Plot and Art by Matthew Jones & Chris Sauerwald"
			     dsCOORD 0 20
			     dsCOLOUR clWHITE
			     dsBACKGROUND clBLACK
            )
            Wait(180)
            Display(
                endscore
                dsCOORD 0 30
                dsCOLOUR clWHITE
                dsBACKGROUND clBLACK
            )
            Wait(180)
            
            Display(
                    timetook
                    dsCOORD 0 140
                    dsCOLOUR clWHITE
                    dsBACKGROUND clBLACK
            )
            Wait(180)
            = dyingScript ScriptID(DYING_SCRIPT)

                (if (< gScore gMaxScore)
                        (send dyingScript:
                            caller(190)
                            register("You finished but missed many things! Play again to try and get all of the points!")
                        )
                )
                (else
                    (if (== gScore gMaxScore)
                        (send dyingScript:
                            caller(192)
                            register("Do you 'really' think you got all of the points? You might be able to go beyond the limit!")
                        )
                    )
                    (else
                        (send dyingScript:
                            //Monkey picture!
                            caller(171)
                            register("Wow! You everything and the secret!! Congratulations!")
                        )
                    )
                )
                
                (send gGame:setScript(dyingScript))
		)
        super:doit()
    )
	(method (init)
		// same in every script, starts things up
  		(super:init())
  		(self:setScript(RoomScript))
        //DEBUG SETTINGS FOR DEVELOPMENT
        //(send gEgo:get(INV_SIX_PACK))
        // = emmaFallen 1
        //= bearOut 2
        //(send gEgo:get(INV_BEER_KEY))\
        //= gotAllGirls 1

        (if (send gEgo:has(INV_BOOM_BOX))
            = south 101
        )
        (else
            = south 200
        )

  		// Check which room ego came from and position it

        //skip the cliff if the person has the boombox... just to make life easier:)

        (if (send gEgo:has(INV_BOOM_BOX))
            = south 101
        )

  		(switch(gPreviousRoomNumber)
           (case 200
  				(send gEgo:
  					posn(150 175)
  					loop(3)
  				)
  			)
            (case 101
                (send gEgo:
                    posn(150 175)
                    loop(3)
                )
            )
            (case 202
                (send gEgo:
                    posn(253 67)
                    loop(2)
                )
            )
            // Set up ego's position if it hasn't come from any room
  			(default
  				(send gEgo:
  					posn(150 175)
  					loop(1)
  				)
  			)
  		)

        //Help out the player
        (if ((== cliffWarp 0) and (send gEgo:has(INV_BOOM_BOX)))
            Print("You were getting tired of walking up and down that path, so you'll take a shortcut next time!")
            =cliffWarp 1
        )
        
		// Set up the ego
		SetUpEgo()
		(send gEgo:init())

        //initialize the six pack if you don't already have it in your inventory
        (if (not (send gEgo:has(INV_SIX_PACK)))
            (sixpack:
                init()
                setLoop(beerUnlock)
            )
        )

        //initialize the mirror if you don't already have it in your inventory
        (if (not (send gEgo:has(INV_MAGIC_MIRROR)))
            (mirror:
                init()
                hide()
                setCycle(Fwd)
                cycleSpeed(0)
            )
        )

        //if the mirror dropped previously make sure its still there
        (if (== mirrorDropped 1)
            (mirror:
                posn(220 50)
                show()
            )
        )
        //init the bear if hes not been taken care of already
        (if (== bearOut 0)
            (bear:
                init()
                setCycle(Walk)
                setMotion(Wander)
            )
        )
        (else //otherwise tell the person that the bear is gone
            (if ( == bearOut 1 )
                Print("The bear seems to have gone somewhere else... ")
                = bearOut 2
            )

        )

        //init the magic door if you have all the girls
        (if (== gotAllGirls 1 )
            (mdoor:
                setCycle(Fwd)
                cycleSpeed(0)
                init()
            )
        )

        //if emma has fallen then initialize her
        (if ((<> emmaFallen 0) and (== gotEmma 0))
            (emma:
                init()
            )

        )

        //if the bear is around init the mauling censor block
        (if (== bearOut 0)
            (censor:
                init()
                hide()
            )
        )
  )
)

/******************************************************************************/
(instance RoomScript of Script
	(properties)

    (method (changeState newState)
        = state newState
    (switch (state)
        (case 0
        = cycles 1
        //Print("0")
        )
        (case 1
        //Print("1")
        )
        (case 2
        //Print("2")
        (User:canControl(TRUE))
        (bear:setMotion(MoveTo 300 70 RoomScript)
            ignoreControl($8000)
            )
        Print("... and he CATCHES IT!\n\nThis could be bad.")
        (beer:hide())
        )
        (case 3
            Print("He's drinking the beer!")
            //(bear:setLoop(1))
            Print("He passed out... well that was easy.\nAs the bear slumped against the tree he knocked a magical mirror to the ground!")
            = bearOut 1
            (send gGame:changeScore(4))
            (mirror:show())
            (mirror:setMotion(MoveTo (220 50)))
            = mirrorDropped 1
        )
    )
    )
	(method (handleEvent pEvent)


        (super:handleEvent(pEvent))

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/
        StrCpy(beertext "")



        (if(== beerUnlock 1)
            StrCat(beertext "sitting next")
        )
        (else
            StrCat(beertext "chained")
        )

        //handle unlocking of the beer
        (if (Said('unlock/beer,chain') )
            (if (not (send gEgo:has(INV_SIX_PACK))) //if ego doesn't have the six pack in inventory
                (if (== beerUnlock 0 ) //if the beer isn't already unlocked
                    (if ( < (send gEgo:distanceTo(sixpack)) 70 ) //if ego is close enough
                        (if (send gEgo:has(INV_BEER_KEY)) //and finally if he has the beer key... unlock it
                            Print("You unlocked the beer.")
                            = beerUnlock 1
                            (sixpack:setLoop(1))
                            (send gGame:changeScore(3))
                        ) //the following else's display the messages if you don't have all the requirements met to unlock the beer
                        (else
                            Print("You need the beer key to unlock the beer.")
                        )
                    )
                    (else
                        Print("You are not close enough.")
                    )
                )
                (else
                    Print("You've already unlocked the beer.")
                )
            )
            (else
                Print("You already have the beer!")
            )
        )

        //handle taking the beer
        (if(Said('take/beer'))
            (if (not (send gEgo:has(INV_SIX_PACK)))    //do we already have it?
                (if ( == beerUnlock 1 ) //is it unlocked?
                    (if ( < (send gEgo:distanceTo(sixpack)) 70 ) //are we close enough?
                        Print("You take the six pack")
                        (send gEgo:get(INV_SIX_PACK))
                        (sixpack:hide())
                        (send gGame:changeScore(2))
                    ) //the following else's display error messages for requirements you haven't met for taking the beer
                    (else
                        Print("You're not close enough to the six pack")
                    )
                )
                (else
                    Print("The beer is chained to the hut.  You need to unlock it.")
                )
            )
            (else
                Print("You already have the six pack!")
            )
        )

        //handle taking the mirror
        (if(Said('take/mirror'))
            (if (not (send gEgo:has(INV_MAGIC_MIRROR))) //don't already have the mirror
                (if ( == mirrorDropped 1 ) //if the mirror has fallen from the tree
                    (if ( < (send gEgo:distanceTo(mirror)) 50 ) //finally if we are close enough we get to take the mirror
                        Print("You take the magic mirror.")
                        (send gEgo:get(INV_MAGIC_MIRROR))
                        (mirror:hide())
                        (send gGame:changeScore(5))
                    ) //the rest of the else's handle error messages if you don't have all the requirements met for taking the mirror
                    (else
                        Print("You are not close enough to the mirror.")
                    )
                )
                (else
                    Print("What mirror?")
                )
            )
            (else
                Print("You already have the mirror!")
            )
        )

        (if (Said('look/mirror'))
            (if (== mirrorDropped 1)
                Print("You see a magic mirror by the tree!")
            )
        )

        (if (Said('throw/beer/bear') )
            (if ((send gEgo:has(INV_SIX_PACK)) and (> beersLeft 0) and (== bearOut 0)) //do you have enough if any beer?
               --beersLeft
               = beerThrown 1 //tell the script that the beer has been thrown
               Print("You throw the beer at the bear...")

                (User:canControl(FALSE)) //make sure you can't move
                (beer:init() //throw the beer animation
                    ignoreControl($8000)
                    ignoreActors()
                    posn((send gEgo:x) (-(send gEgo:y) 20))
                    setCycle(Fwd)
                    cycleSpeed(1)
                    setPri(0)
                    //Handled by the RoomScript at this point
                    setMotion(MoveTo (- (bear:x) 40) (- (bear:y) 40) RoomScript)
                )

               (bear:
                    setMotion(NULL)
                    setLoop(1)
               )
            )
            (else
                Print("You need some beer to throw!")
            )
        )
        
        (if (Said('give/beer/bear'))
            (if (send gEgo:has(INV_SIX_PACK)) //do you have enough if any beer?
                (if (== bearOut 0)
                    Print("Theres no way you're getting close enough to give the beer to the bear!")
                )
                (else
                    Print("The bear isn't here!")
                )
            )
            (else
                Print("You don't have that!")
            )
        )
        
        (if(Said('hump/bear'))
            (if (== bearOut 1)
                Print("No, this isn't adventureland, no sex with bears in this game.")
            )
        )
        
        
        //easter egg... taking a leak(inspired by Space Quest 1(tm)
        (if ( (Said('take/leak')) or (Said('pee')))
            (if (== tookLeak 0 )   //if you haven't already
                (if (> beersDrank 0) //if you have drank some beers
                    (if (== (send gEgo:onControl()) $0002) //and finally if you are behind the hut or tree you are allowed to take a leek
                        Print("You feel much better.")
                        (send gGame:changeScore(1))
                    ) //the following else's handle the error messages if you dno't have all the requirements met for taking a leak
                    (else
                        Print("You aren't really just going to go out in the open are you?")
                    )
                )
                (else
                    Print("You haven't drank any beer yet.")
                )
            )
            (else
                Print("You can't possibly have to go again!")
            )
        )

        //handle climbing the tree
        (if (Said('climb/tree') )
            (if (<> bearOut 0) //if the bear is knocked out
                (if ((== (send gEgo:onControl()) $1000) or (== (send gEgo:onControl()) $0002)) //and if your on a tree control you're allowed to climb
                    Print("You climb the tree.")
                    (send gRoom:newRoom(202))
                ) //else's handle error messages when requirements are not met
                (else
                    Print("You are not close enough to the tree.")
                )
            )
            (else
                Print("You don't want to climb a tree while there is a big bear roaming around do you?")
            )
        )

        //handle taking emma
        (if (Said('take/emma,girl,chick'))
            (if ((<> emmaFallen 0 ) and (== gotEmma 0))
                Print("She won't come with you willingly")
            )
            (else
                Print("Emma isn't anywhere nearby!")
            )
        )

        //handle using the mirror on emma
        (if (Said('use/mirror/emma,girl,chick'))
            (if ((== gotEmma 0) and (<> emmaFallen 0)) //make sure shes actually in the room
                (if (< (send gEgo:distanceTo(emma)) 50 ) //make sure you are close enough.
                    Print("You use the magic mirror to transport emma back to the hot chicks room")
                    = gotEmma 1
                    (send gGame:changeScore(5))
                    (emma:hide())
                )
                (else
                    Print("You are not close enough to emma to use the mirror.  Its not THAT magical!")
                )
            )
            (else
                Print("You can't use the mirror on Emma... shes not HERE!")
            )
        )

        (if (Said('throw/beer') )
            Print("Where do you want to throw the beer?")
        )


        //handle look actions
        (if(Said('look/hut'))
            Print("The hut is too small for a person, it must belong to the bear.")
            (if (== gotAllGirls 1 )
                Print("There is a strange portal on the hut now.")
            )
            (if (not (send gEgo:has(INV_SIX_PACK)))
                FormatPrint(("There is a six pack of beer %s to the hut." beertext))
            )
        )

        (if(Said('look/bear'))
            (if (== bearOut 0)
                Print("Don't mess with this guy... you've got to figure out a way to knock him out")
            )
            (else
                (if (== bearOut 1)
                    Print("The bear is knocked out. Wahooo!")
                )
                (else
                    Print("The bear isn't here anymore!")
                )
            )
        )

        (if(Said('look/tree'))
            (if (== bearOut 0)
                Print("If you could knock that bear out you might be able to climb this tree.")
            )
            (else
                Print("Its a very large tree.  When you look up you can see an area high up in it that you might be able to climb too.")
            )
        )

        (if(Said('look<up'))
            Print("You see blue.")
        )

        (if(Said('look/emma,girl,chick'))
            (if (== gotEmma 0) //if we don't have emma yet
                (if (<> emmaFallen 1 ) //if emma didn't just fall out of the tree
                    Print("Its Emma. One of the hot chicks!")
                )
                (else
                    (if (== emmaFallen 1)    //if emma has just fallen
                        Print("Emma seems to be fine.  Now that shes within reach maybe you can get her to the hot chicks room.")
                        = emmaFallen 2
                    )
                    (else //emma fallen must be equal to zero.. which means shes never been in this room yet.
                        Print("Emma isn't anywhere nearby")
                    )
                )
            )
            (else
                Print("Emma is already back in the hot chicks room.  If you want to look.... go back there!")
            )
        )

        (if(Said('look'))
            Print("You see a small hut and a large tree.")
        )

        //handle talking actions

        //handle talking to the bear
        (if(Said('talk/bear'))
            (if (== bearOut 0)
                Print("grrrrr. arggggh. look up see blue.")
            )
            (else
                (if (== bearOut 1)
                    Print("Yeah... good idea... why don't we wake him back up.... try again.")
                )
                (else
                    Print("The bear isn't around!")
                )
            )
        )

        //handle talking to emma
        (if(Said('talk/emma,girl'))
            (if (== gotEmma 0)
                Print("That fall could have hurt... good thing I'm so light I defy the laws of physics. HEHE")
            )
            (else
                Print("Emma isn't anywhere around")
            )
        )

        //misc talkign stuff
        (if(Said('talk/hut'))
            Print("What are you smoking?")
        )

        (if(Said('talk/tree'))
            Print("Yeah... ok... ")
        )





 	)
)
/******************************************************************************/

(instance sixpack of Prop
    (properties
        x 159
        y 70
        view 201
    )
)

(instance bear of Act
    (properties
        x 280
        y 65
        view 259
    )
)

(instance mirror of Act
    (properties
        x 220
        y 30
        view 203
    )
)

(instance censor of Prop
    (properties
        x 0
        y 0
        view 250
    )
)

(instance emma of Prop
    (properties
        x 210
        y 65
        view 192
    )
)

//Instance of the flying beer
(instance beer of Act
    (properties
        x 220
        y 90
        view 287
    )
)

//the magic door
(instance mdoor of Prop
    (properties
        x 108
        y 72
        view 265
    )
)
