/******************************************************************************
 Tree script (rm202)
 Chris Sauerwald (csauerwa@umich.edu)
 CIS 487 Hot Chicks Room adventure.
 altered template script from SCI Studio.
 ******************************************************************************/
(include "sci.sh")
(include "game.sh")
/******************************************************************************/
(script 202)
/******************************************************************************/
(use "main")
(use "controls")
(use "cycle")
(use "game")
(use "feature")
(use "obj")
(use "inv")
(use "door")
(use "jump")
(use "dpath")
(use "wander")
(use "user")
/******************************************************************************/
(local
    dead=0
    falling=0
)
(instance public rm202 of Rm
	(properties
		picture scriptNumber
		// Set up the rooms to go to/come from here
		north 0
		east 0
		south 201
		west 0
	)
    (method (doit)
        (var dyingScript)
        (if(( == (send gEgo:onControl()) $0010) and (== falling 0) )

            //drop the branch
            (branch:
                ignoreControl($8000)
                setMotion(MoveTo 27 210)
                setPri(1)
            )

            //drop emma
            (emma:
                ignoreControl($8000)
                setMotion(MoveTo 27 210)
                setPri(1)
            )

            //drop ego(maybe)
            (User:
                canControl(FALSE)
            )

            (send gEgo:
                ignoreControl($8000)
                setMotion(MoveTo 27 210)
                setPri(1)
            )
            = falling 1
        )

        (if ((== (send gEgo:onControl()) $0200 ) and (== dead 0))
           = dyingScript ScriptID(DYING_SCRIPT)
           //call death script
           (send dyingScript:
                caller(3)
                register("All the ben-gay in florida isn't going to remove that stiffness, you're dead.")
           )
           (send gGame:setScript(dyingScript))
           = dead 1
       )
       (super:doit())
    )
	(method (init)
		// same in every script, starts things up
  		(super:init())
  		(self:setScript(RoomScript))
        //DEBUG SETTINGS FOR DEVELOPMENT
        //(send gEgo:get(INV_SIX_PACK))
  		// Check which room ego came from and position it
  		(switch(gPreviousRoomNumber)
            (case 201
  				(send gEgo:
  					posn(180 170)
  					loop(3)
  				)
  			)
            // Set up ego's position if it hasn't come from any room
  			(default
  				(send gEgo:
  					posn(180 170)
  					loop(1)
  				)
  			)
  		)

		// Set up the ego
		SetUpEgo()
		(send gEgo:init())

        (branch:
            init()
            ignoreActors()
            setPri(0)
        )
        (if (== emmaFallen 0)
            (emma:
                init()
                setPri(1)
            )
        )

        /**************************************************
         * Add the rest of your initialization stuff here *
         **************************************************/
  )
)
/******************************************************************************/
(instance RoomScript of Script
	(properties)
     (method (changeState newState)
        = state newState
    (switch (state)
        (case 0
        = cycles 1
        //Print("0")
        )
        (case 1
        //Print("1")
        )
        (case 2
        //Print("2")
        Print("She catches it and drinks it...")
        Print("Emma looks a bit wobbly and falls off the branch")
        (emma:
            ignoreControl($8000)
            setPri(1)
            setMotion(MoveTo 27 190 RoomScript)
        )
        (beer:hide())
        )
        (case 3
            Print("Emma has fallen out of the tree! (though rather slowly).  You'd better go down there and check on her")
            = emmaFallen 1
            (emma:hide())
            (send gGame:changeScore(4))
            (User:canControl(TRUE))
        )
    )
    )


	(method (handleEvent pEvent)

        (super:handleEvent(pEvent))

        /*****************************************
         * Handle the possible said phrases here *
         *****************************************/


        //handle throwing the beer to emma
        (if(Said('throw/beer/emma,girl') )
            (if ((== emmaFallen 0 ) and (== gotEmma 0 ))
                (if ((send gEgo:has(INV_SIX_PACK)) and (> beersLeft 0))
                    Print("You throw a beer at emma.")
                    --beersLeft
                    (User:canControl(FALSE))
                    (send gEgo:setMotion(NULL))
                    
                    (beer:init()
                        ignoreControl($8000)
                        ignoreActors()
                        posn((send gEgo:x) (-(send gEgo:y) 20))
                        setCycle(Fwd)
                        cycleSpeed(1)
                        setPri(0)
                        //Handled by the RoomScript at this point
                        setMotion(MoveTo ((emma:x)) (- (emma:y) 20) RoomScript)
                    )
                )
                (else
                    Print("You don't have any beer!")
                )
            )
            (else
                Print("Emma Isn't here!")
            )
        )

        //If they want to try to help her
        (if(Said('help/girl,emma'))
            (if ((== emmaFallen 0 ) and (== gotEmma 0 ))
                Print("Why don't you go over and try to help her")
            )
            (else
                Print("She's not here!")
            )
        )

        (if(Said('throw/beer'))
            (if ((== emmaFallen 0 ) and (== gotEmma 0 ))
                Print("Where do you want to throw it!?")
            )
        )

        (if (Said('give/beer/girl,emma'))
            (if ((== emmaFallen 0 ) and (== gotEmma 0 ))
                Print("Get Closer!!")
            )
            (else
                Print("Emma isn't here!")
            )
        )

        //handle using mirror on emma(never actually works) because she needs to be out of the tree
        (if (Said('use/mirror/emma,girl,chick'))
            (if ((== emmaFallen 0 ) and (== gotEmma 0 ))
                (if (send gEgo:has(INV_MAGIC_MIRROR))
                    Print("You are not close enough!")
                )
                (else
                    Print("You don't have a mirror genious.")
                )
            )
            (else
                Print("Emma isn't here!")
            )
        )

        /**********************************
            handle looking at things
        *********************************/

        (if(Said('look/branch'))
            Print("The branches in this tree are HUGE.  At least twice as wide as the path you took to get to this cliff.  The artist must be on crack.")
        )

        //handle looking at emma
        (if(Said('look/emma,girl') )
            (if ((<> emmaFallen 0 ) and (== gotEmma 0))
                Print("Seeing as how Emma has fallen out of the tree you have to GO DOWN to look at her!")
            )
            (else
                (if (== gotEmma 0)
                    Print("Its Emma! One of the hot chicks!  Shes on a dangerously thin branch.")
                )
                (else
                    Print("Emma isn't here!")
                )
            )
        )

        //general look handler
        (if(Said('look'))
                Print("You are in the one clear area in the tree.")
                (if (== emmaFallen 0)
                    Print ("You see a dangerously hot chick on a dangerously thin branch")
                )
        )

        /*********************
            handle talking
        *********************/

        (if(Said('talk/emma,girl'))
            (if (== emmaFallen 0)
                Print("I must have drank too much.  I have no idea how I ended up in this tree.  Could you help me?")
            )
            (else
                Print("Emma isn't even here!")
            )
        )

    )
)

//instance of the thin branch
(instance branch of Act
    (properties
        x 27
        y 66
        view 202
    )
)

//instance of emma
(instance emma of Act
    (properties
        x 27
        y 65
        view 192
    )
)

//Instance of the flying beer
(instance beer of Act
    (properties
        x 220
        y 90
        view 287
    )
)
/******************************************************************************/
